Subject: RE: bug#42994: 27.1; json-serialize unable to serialize JSON values

From: Drew Adams <[email-masked]>
Date: Sun, 23 Aug 2020 09:21:03 -0700 (PDT)

> According to the [JSON spec]
> (https://www.json.org/json-en.html),
> everything is a value and every value is a valid JSON, which means
> literal string, numbers, and true, false and null are also valid JSON
> values, but `json-serialize` is unable to serialize literals. This is
> wrong and behaviorialy different from the elisp-based `json-encode`.

All JSON scalars are JSON values.

Whether a JSON scalar is sufficient for a document
(a JSON text) to be considered a JSON document
(aka text) depends on whether RFC 8259 is supported.

https://tools.ietf.org/html/rfc8259

When someone speaks of "a JSON", if they mean a
JSON text (aka document), then whether that RFC is
supported determines the status of a scalar value.

Prior to that RFC, and for applications/systems that
don't support it, only JSON objects and arrays need
be considered JSON texts.

Put differently, if only RFC 7159 or RFC 4627 is
supported, and not also RFC 8259, then a document
with just a scalar (which is a JSON _value_) isn't
necessarily considered a JSON document.

>From RFC 8259:

   A JSON text is a serialized value.  Note that
   certain previous specifications of JSON
   constrained a JSON text to be an object or an
   array.  Implementations that generate only
   objects or arrays where a JSON text is called
   for will be interoperable in the sense that all
   implementations will accept these as conforming
   JSON texts.